﻿'Project:       Test 2
'Programmer:    Seth McNamee
'Description:   This project calculates the amount each person pays when splitting a bill.



Option Strict On
Option Explicit On
Public Class BillSplitForm

    Private Sub btnClear_Click(sender As Object, e As EventArgs) Handles btnClear.Click
        'Clear the form
        'Add code here to reset the Combo Box Control
        cboPersonName.SelectedIndex = -1

        txtAmount.Text = ""
        txtAmount.Focus()


    End Sub



    Private Sub btnExit_Click(sender As Object, e As EventArgs) Handles btnExit.Click
        Me.Close()
    End Sub

    Private Sub BillSplitForm_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        'Adds a persons name to the list at runtime
        cboPersonName.Items.Add("Zach")
        cboPersonName.Items.Add("Anne")
        cboPersonName.Items.Add("James")

        'sorts the name in the combo box at runtime
        cboPersonName.Sorted = True

    End Sub

    Private Sub btnCalc_Click(sender As Object, e As EventArgs) Handles btnCalc.Click
        'Calculate the amount each person pays using the following information
        '1.Divide the total Bill Amount by the number of people in the combo list
        '2.round the result of the division so there are not any fraction of a cent (two decimal places) 
        '  And so the sum of each person's payment is not less than the total bill amount
        '3.The double Check value is the result of each Person Pays Amount multiplied by the number of people in the combo list
        Dim decAmountDue As Decimal = 0.0D
        Dim decEachPerson As Decimal = 0.0D
        Dim decDoubleCheck As Decimal = 0.0D
        Dim intPeople As Integer = 0

        'Validates Input
        If txtAmount.Text = "" Then 'checks to see if the textbox is empty
            MessageBox.Show("Please enter the Amount that is due", "Input Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        ElseIf Not IsNumeric(txtAmount.text) Then 'checks to see if the textbox cantains numbers
            MessageBox.Show("Please enter a number for the amount due", "Input Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        ElseIf CDec(txtAmount.text) <= 0 Then 'checks to see if it is greater than zero
            MessageBox.Show("Please enter a positive number for the amount due", "Input Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        ElseIf cboPersonName.SelectedIndex = -1 Then
            MessageBox.Show("Please select a person's name for the list", "Input Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Else

            decAmountDue = CDec(txtAmount.Text)
            intPeople = cboPersonName.Items.Count

            'finds how much each persons owes
            decEachPerson = decAmountDue / CDec(intPeople)

            'rounds the number away from zero
            Math.Round(decEachPerson, 2, MidpointRounding.AwayFromZero)

            'double checks the amount Due
            decDoubleCheck = decEachPerson * CDec(intPeople)


            'displays the values to the form
            lblEachPay.Text = decEachPerson.ToString("C")
            lblDoubleCheck.Text = decDoubleCheck.ToString("C")

        End If

    End Sub

    Private Sub btnDeleteName_Click(sender As Object, e As EventArgs) Handles btnDeleteName.Click
        'deletes a selected name from the list
        Dim intGetNameIndex As Integer = 0

        'checks to see if a name has been picked
        If cboPersonName.SelectedIndex = -1 Then
            MessageBox.Show("please select a name you would like to delete", "Input Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Else
            intGetNameIndex = cboPersonName.SelectedIndex

            'deletes name from the form
            cboPersonName.Items.RemoveAt(intGetNameIndex)
        End If
    End Sub

    Private Sub btnAddName_Click(sender As Object, e As EventArgs) Handles btnAddName.Click
        'adds a name to the combo box list also checks to see that no duplicate names are added using a FOR NEXT loop
        Dim strAddName As String = ""
        Dim intCounter As Integer = 0
        Dim blnFindName As Boolean = False

        If cboPersonName.Text = "" Then 'checks to see if there is text in the combo box
            MessageBox.Show("Please enter a name you would like to enter into the list", "Input Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Else
            strAddName = cboPersonName.Text

            For intCounter = 0 To (cboPersonName.Items.Count - 1)
                If strAddName.ToUpper = cboPersonName.Items(intCounter).ToString.ToUpper Then 'checks to see if the strAddName text is already in the list
                    blnFindName = True
                End If
            Next

            'Add Name to the List
            If blnFindName = True Then
                MessageBox.Show("Name is already added to the list Please enter another name", "Input Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Else
                cboPersonName.Items.Add(strAddName)
            End If
        End If
    End Sub
End Class
